local minimizeAfterCombat=false
local slashOpts={}
local chan={}
local channelsRcvdByWindow={}
local msgsRcvdByWindow={}
local handleCount=1
local lower={}

MiniChat=AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceEvent-2.0","AceDB-2.0","AceHook-2.1")
MiniChat:RegisterDB("MiniChatDB")
MiniChat:RegisterDefaults("profile",{
 ChatHeight={0,0,0,0,0,0,0},
 ChatLeft={0,0,0,0,0,0,0},
 ChatBottom={0,0,0,0,0,0,0},
 Minimized={false,false,false,false,false,false,false},
 Alpha=1.0,
 ChatAlphaEnabled=false,
 ChatMinAlpha=1.0,
 ChatMaxAlpha=1.0,
 Clamped=true,
 Scale=1.0,
 Unlock=false,
 HandleAll=false,
 CustomX=0,
 CustomY=0,
 Position="topright",
 AnimationSpeed=0,
 Direction="down",
 SmartMinimize=true,
 AutoMinimize=false,
 AutoMinimizeAfter=60,
 AutoMaximizeEnabled=false,
 AutoMaximizeIgnoreIfInCombat=false,
 AutoMaximizeIgnoreSelf=false,
 AutoMaximizeOnYell=false,
 AutoMaximizeOnSay=false,
 AutoMaximizeOnWhisper=false,
 AutoMaximizeOnGuild=false,
 AutoMaximizeOnParty=false,
 AutoMaximizeOnRaid=false,
 AutoMaximizeOnBattleground=false,
 AutoMaximizeOnOfficer=false,
 AutoMaximizeOnChannel={}
})
waterfall=AceLibrary("Waterfall-1.0")

function MiniChat:UpdateOptions()
 slashOpts={
  type='group',
  args={
   alpha={
    type='range',
    name='Alpha value of MiniChat button',
    desc='Adjusts transparency of the MiniChat button.',
    usage="(0.0-1.0), 0=invisible, 1=opaque. Note: The button will always be opaque on mouse over.",
    step=0.05,
    get="GetAlpha",
    set="SetAlpha"
   },
   scale={
    type='range',
    name='Size of MiniChat button',
    desc='Adjusts the size of the MiniChat button.',
    usage='(0.1-2.0)',
    min=0.1,
    max=2.0,
    step=0.1,
    get="GetScale",
    set="SetScale"
   },
   handleall={
    type='toggle',
    name='Min- und maximize all chat frames',
    desc='When active, all chat frames will minimize and maximize like the default chat frame.',
    get="GetHandleAll",
    set="SetHandleAll"
   },
   clamped={
    type='toggle',
    name='Clamp MiniChat button to screen',
    desc='When active, the MiniChat button can\'t be moved out of the screen if unlocked.',
    get="GetClamped",
    set="SetClamped"
   },
   unlock={
    type='toggle',
    name='Unlock the MiniChat button',
    desc='Move the MiniChat button with your mouse. Note: Once moved, the button will never change it\'s position on min-/maximization until Position is set again.',
    get="GetUnlock",
    set="SetUnlock"
   },
   position={
    type='text',
    name='Position',
    desc='Sets the position of the MiniChat button.',
    usage="(topright|bottomright|bottomleft|topleft)",
    get="GetPosition",
    set="SetPosition",
    validate={"topright","bottomright","bottomleft","topleft"}
   },
   animationSpeed={
    type='range',
    name='Speed for min-/maximizing (0=no animation)',
    desc='Defines the speed for min-/maximizing the chat window.',
    usage='(0-100)',
    min=0,
    max=100,
    step=1,
    get="GetAnimationSpeed",
    set="SetAnimationSpeed"
   },
   direction={
    type='text',
    name='Direction',
    desc='Defines the direction which MiniChat minimizes to.',
    usage="(up|down)",
    get="GetDirection",
    set="SetDirection",
    validate={"up","down"}
   },
   smartMinimize={
    type='toggle',
    name='Smart minimize',
    desc='On minimization, the chat window height will be set to the height of the last message instead of the height of one line.',
    get="GetSmartMinimize",
    set="SetSmartMinimize"
   },
   autoMinimize={
    type='toggle',
    name='Auto minimize',
    desc='Minimizes the chat window automatically.',
    get="GetAutoMinimize",
    set="SetAutoMinimize"
   },
   autoMinimizeAfter={
    type='range',
    name='Auto minimize after',
    desc='Minimizes the chat window after x seconds.',
    usage="(5-600)",
    min=5,
    max=600,
    step=1,
    bigstep=10,
    get="GetAutoMinimizeAfter",
    set="SetAutoMinimizeAfter"
   },
   chatAlpha={
    type='group',
    name='Chat Alpha',
    desc='Sets the alpha values of the chat windows for minimized and maximized states. Note: This will affect the font, too.',
    args={
     enabled={
      type='toggle',
      name='Enabled',
      desc='Enables different alpha values.',
      get="GetChatAlphaEnabled",
      set="SetChatAlphaEnabled"
     },
     minAlpha={
      type='range',
      name='Alpha value for minimized state',
      desc='The chat windows will take on this alpha value when minimized.',
      usage="(0.0-1.0), 0=invisible, 1=opaque.",
      step=0.05,
      get="GetChatMinAlpha",
      set="SetChatMinAlpha"
     },
     maxAlpha={
      type='range',
      name='Alpha value for maximized state',
      desc='The chat windows will take on this alpha value when maximized.',
      usage="(0.0-1.0), 0=invisible, 1=opaque.",
      step=0.05,
      get="GetChatMaxAlpha",
      set="SetChatMaxAlpha"
     }
    }
   },
   autoMaximize={
    type='group',
    name='Auto maximize',
    desc='Maximizes the chat window if certain message types are received. This does not ignore messages from muted channels.',
    args={
     enabled={
      type='toggle',
      name='Enabled',
      desc='Enables autoMaximize.',
      get="GetAutoMaximizeEnabled",
      set="SetAutoMaximizeEnabled"
     },
     ignoreSelf={
      type='toggle',
      name='Ignore your messages',
      desc='Don\'t maximize if messages are sent by you.',
      get="GetAutoMaximizeIgnoreSelf",
      set="SetAutoMaximizeIgnoreSelf"
     },
     ignoreIfInCombat={
      type='toggle',
      name='Suppress maximization while in combat.',
      desc='Chat won\'t maximize while in combat but maximization will be scheduled if important events happen during combat.',
      get="GetAutoMaximizeIgnoreIfInCombat",
      set="SetAutoMaximizeIgnoreIfInCombat"
     },
     onYell={
      type='toggle',
      name='on yell',
      desc='Maximizes the chat window when a yell (/y) is received.',
      get="GetAutoMaximizeOnYell",
      set="SetAutoMaximizeOnYell"
     },
     onSay={
      type='toggle',
      name='on say',
      desc='Maximizes the chat window whenever a message (/s) is received.',
      get="GetAutoMaximizeOnSay",
      set="SetAutoMaximizeOnSay"
     },
     onWhisper={
      type='toggle',
      name='on whisper',
      desc='Maximizes the chat window whenever a whisper (/w) is received.',
      get="GetAutoMaximizeOnWhisper",
      set="SetAutoMaximizeOnWhisper"
     },
     onGuild={
      type='toggle',
      name='on guild',
      desc='Maximizes the chat window whenever a guild message (/g) is received.',
      get="GetAutoMaximizeOnGuild",
      set="SetAutoMaximizeOnGuild"
     },
     onParty={
      type='toggle',
      name='on party',
      desc='Maximizes the chat window whenever a party message (/p) is received.',
      get="GetAutoMaximizeOnParty",
      set="SetAutoMaximizeOnParty"
     },
     onRaid={
      type='toggle',
      name='on raid',
      desc='Maximizes the chat window whenever a raid message (/ra) is received.',
      get="GetAutoMaximizeOnRaid",
      set="SetAutoMaximizeOnRaid"
     },
     onBattleground={
      type='toggle',
      name='on battleground',
      desc='Maximizes the chat window whenever a battleground message (/bg or battleground system message) is received.',
      get="GetAutoMaximizeOnBattleground",
      set="SetAutoMaximizeOnBattleground"
     },
     onOfficer={
      type='toggle',
      name='on officer',
      desc='Maximizes the chat window whenever an officer message (/o) is received.',
      get="GetAutoMaximizeOnOfficer",
      set="SetAutoMaximizeOnOfficer"
     },
     onChannel={
      type='group',
      name='on channel',
      desc='Maximizes the chat window whenever a message is received in custom channels.',
      args={
       channel01={
        type='toggle',
        name='01: '..tostring(chan[1]),
        desc='Enables autoMaximize for channel01',
        get="GetAutoMaximizeOnChannel1",
        set="SetAutoMaximizeOnChannel1"
       },
       channel02={
        type='toggle',
        name='02: '..tostring(chan[2]),
        desc='Enables autoMaximize for channel02',
        get="GetAutoMaximizeOnChannel2",
        set="SetAutoMaximizeOnChannel2"
       },
       channel03={
        type='toggle',
        name='03: '..tostring(chan[3]),
        desc='Enables autoMaximize for channel03',
        get="GetAutoMaximizeOnChannel3",
        set="SetAutoMaximizeOnChannel3"
       },
       channel04={
        type='toggle',
        name='04: '..tostring(chan[4]),
        desc='Enables autoMaximize for channel04',
        get="GetAutoMaximizeOnChannel4",
        set="SetAutoMaximizeOnChannel4"
       },
       channel05={
        type='toggle',
        name='05: '..tostring(chan[5]),
        desc='Enables autoMaximize for channel05',
        get="GetAutoMaximizeOnChannel5",
        set="SetAutoMaximizeOnChannel5"
       },
       channel06={
        type='toggle',
        name='06: '..tostring(chan[6]),
        desc='Enables autoMaximize for channel06',
        get="GetAutoMaximizeOnChannel6",
        set="SetAutoMaximizeOnChannel6"
       },
       channel07={
        type='toggle',
        name='07: '..tostring(chan[7]),
        desc='Enables autoMaximize for channel07',
        get="GetAutoMaximizeOnChannel7",
        set="SetAutoMaximizeOnChannel7"
       },
       channel08={
        type='toggle',
        name='08: '..tostring(chan[8]),
        desc='Enables autoMaximize for channel08',
        get="GetAutoMaximizeOnChannel8",
        set="SetAutoMaximizeOnChannel8"
       },
       channel09={
        type='toggle',
        name='09: '..tostring(chan[9]),
        desc='Enables autoMaximize for channel09',
        get="GetAutoMaximizeOnChannel9",
        set="SetAutoMaximizeOnChannel9"
       },
       channel10={
        type='toggle',
        name='10: '..tostring(chan[10]),
        desc='Enables autoMaximize for channel10',
        get="GetAutoMaximizeOnChannel10",
        set="SetAutoMaximizeOnChannel10"
       }
      }
     }
    }
   },
   gui={
    type='execute',
    guiHidden=true,
    name='GUI',
    desc='Opens GUI config.',
    func=function()
     waterfall:Open('MiniChat GUI')
    end
   }
  }
 }
 MiniChat:RegisterChatCommand("/mc","/minichat",slashOpts)
 waterfall:Register('MiniChat GUI','aceOptions',slashOpts,'title')
end

function MiniChat:ChatFrame_MessageEventHandler()
 if(self.db.profile.SmartMinimize) then
  for i=1,handleCount do
   if(self.db.profile.Minimized[i]) then
    getglobal("ChatFrame"..i):SetHeight(self:GetLastMsgHeight(i))
   end
   self:UpdateChatAlpha(i)
  end
 end
end

local MiniB=CreateFrame("Button",nil,UIParent)

function MiniChat:OnInitialize()
 for i=1,10 do
  local _,channelname=GetChannelName(i)
  if(channelname==nil) then
   chan[i]="-"
  else
   chan[i]=channelname
  end
 end
 self:UpdateOptions()
end

function MiniChat:OnDisable()
 MiniB:Hide()
 self:Unhook("ChatFrame_MessageEventHandler")
end

function MiniChat:OnEnable()
 self:SecureHook("ChatFrame_MessageEventHandler")
 for i=1,NUM_CHAT_WINDOWS do
  channelsRcvdByWindow[i]={GetChatWindowChannels(getglobal("ChatFrame"..i):GetID())}
  msgsRcvdByWindow[i]={GetChatWindowMessages(getglobal("ChatFrame"..i):GetID())}
  lower[i]=self:GetLastMsgHeight(i)
 end
 if(self.db.profile.HandleAll) then
  handleCount=NUM_CHAT_WINDOWS
 end

 MiniB:SetFrameStrata("Low")
 MiniB:SetWidth(15*self:GetScale())
 MiniB:SetHeight(15*self:GetScale())
 MiniB:SetAlpha(self:GetAlpha())
 
 if(self:GetClamped()) then
  MiniB:SetClampedToScreen(true)
 end

 --MiniB:SetNormalTexture("Interface\\Glues\\CharacterCreate\\UI-RotationRight-Big-Up.blp")
 --MiniB:SetPushedTexture("Interface\\Glues\\CharacterCreate\\UI-RotationRight-Big-Down.blp")
 if(self.db.profile.Minimized[1]) then
  MiniB:SetNormalTexture("Interface\\Addons\\MiniChat\\textures\\button-up.tga")
  MiniB:SetPushedTexture("Interface\\Addons\\MiniChat\\textures\\button-up-pushed.tga")
 else
  MiniB:SetNormalTexture("Interface\\Addons\\MiniChat\\textures\\button-down.tga")
  MiniB:SetPushedTexture("Interface\\Addons\\MiniChat\\textures\\button-down-pushed.tga")
 end

 self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE")
 self:RegisterEvent("MINICHAT_SMOOTHING")
 self:RegisterEvent("MINICHAT_AUTOMINIMIZE")
 self:RegisterEvent("CHAT_MSG_CHANNEL")
 self:RegisterEvent("CHAT_MSG_OFFICER")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE")
 self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL")
 self:RegisterEvent("CHAT_MSG_BATTLEGROUND")
 self:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
 --self:RegisterEvent("UPDATE_WORLD_STATES")
 self:RegisterEvent("CHAT_MSG_PARTY")
 self:RegisterEvent("CHAT_MSG_RAID")
 self:RegisterEvent("CHAT_MSG_RAID_LEADER")
 self:RegisterEvent("CHAT_MSG_GUILD")
 self:RegisterEvent("CHAT_MSG_SAY")
 self:RegisterEvent("CHAT_MSG_WHISPER")
 self:RegisterEvent("CHAT_MSG_WHISPER_INFORM")
 self:RegisterEvent("CHAT_MSG_YELL")
 self:RegisterEvent("PLAYER_REGEN_ENABLED")
 
 for i=1,handleCount do
  if(self.db.profile.AutoMinimize and not self.db.profile.Minimized[i]) then
   self:MiniMax(i)
  end
 end

 if(self:GetPosition()=="custom") then
  MiniB:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",self.db.profile.CustomX,self.db.profile.CustomY) 
 else
  MiniB:SetPoint("CENTER",DEFAULT_CHAT_FRAME,self.db.profile.Position,0,0)
 end
 MiniB:SetMovable(true)
 MiniB:Show()

 -- MouseDown on button
 MiniB:SetScript("OnMouseDown",function()
  if(self:GetUnlock()) then
   MiniB:StartMoving()
   self.db.profile.Position="custom"
  end
 end)
  -- MouseUp on button
 MiniB:SetScript("OnMouseUp",function()
  MiniB:StopMovingOrSizing()
  self.db.profile.CustomX=MiniB:GetLeft()
  self.db.profile.CustomY=MiniB:GetTop()
 end)

 -- Button clicked
 MiniB:SetScript("OnClick",function()
  for i=1,handleCount do
   self.db.profile.ChatLeft[i]=getglobal("ChatFrame"..i):GetLeft()
   self.db.profile.ChatBottom[i]=getglobal("ChatFrame"..i):GetBottom()
  end
  for i=handleCount,1,-1 do
   if(self.db.profile.Minimized[i]==self.db.profile.Minimized[1]) then
    self:MiniMax(i)
   end
  end
 end)

 -- Mouse leaves button 
 MiniB:SetScript("OnLeave",function()
  MiniB:SetAlpha(self.db.profile.Alpha)
 end)
  -- Mouse is moved over button
 MiniB:SetScript("OnEnter",function()
  MiniB:SetAlpha(1)
 end)
end

-- Thanks to Ellipsis for this one
function MiniChat:GetLastMsgHeight(i)
 if(not self.db.profile.SmartMinimize) then
  local _,fontheight=getglobal("ChatFrame"..i):GetFont()
  return fontheight
 end
 local _,line=getglobal("ChatFrame"..i):GetRegions()
 if(line) then
  return line:GetHeight() -- ceil/floor?
 else
  local _,fontheight=getglobal("ChatFrame"..i):GetFont()
  return fontheight
 end
end


function MiniChat:UpdateChatAlpha(i)
 if(self.db.profile.ChatAlphaEnabled) then
  getglobal("ChatFrame"..i):SetAlpha(
   (getglobal("ChatFrame"..i):GetHeight()-lower[i])/(self.db.profile.ChatHeight[i]-lower[i])*self.db.profile.ChatMaxAlpha
   +
   (1.0-(getglobal("ChatFrame"..i):GetHeight()-lower[i])/(self.db.profile.ChatHeight[i]-lower[i]))*self.db.profile.ChatMinAlpha
  )
 end
end


function MiniChat:ScanTable(string,table)
 for i=1,#table do
  if(string==table[i]) then
   return true
  end
 end
 return false
end


function MiniChat:GetAlpha()
 return self.db.profile.Alpha
end
function MiniChat:SetAlpha(newAlpha)
 self.db.profile.Alpha=newAlpha
 MiniB:SetAlpha(newAlpha)
end

function MiniChat:GetChatAlphaEnabled()
 return self.db.profile.ChatAlphaEnabled
end
function MiniChat:SetChatAlphaEnabled(newChatAlphaEnabled)
 self.db.profile.ChatAlphaEnabled=newChatAlphaEnabled
 if(newChatAlphaEnabled) then
  for i=1,handleCount do
   if(self.db.profile.Minimized[i]) then
    getglobal("ChatFrame"..i):SetAlpha(self.db.profile.ChatMinAlpha)
   else
    getglobal("ChatFrame"..i):SetAlpha(self.db.profile.ChatMaxAlpha)
   end
  end 
 end
end
function MiniChat:GetChatMinAlpha()
 return self.db.profile.ChatMinAlpha
end
function MiniChat:SetChatMinAlpha(newChatMinAlpha)
 self.db.profile.ChatMinAlpha=newChatMinAlpha
 for i=1,handleCount do
  if(self.db.profile.ChatAlphaEnabled and self.db.profile.Minimized[i]) then
   getglobal("ChatFrame"..i):SetAlpha(newChatMinAlpha)
  end
 end
end
function MiniChat:GetChatMaxAlpha()
 return self.db.profile.ChatMaxAlpha
end
function MiniChat:SetChatMaxAlpha(newChatMaxAlpha)
 self.db.profile.ChatMaxAlpha=newChatMaxAlpha
 for i=1,handleCount do
  if(self.db.profile.ChatAlphaEnabled and not self.db.profile.Minimized[i]) then
   getglobal("ChatFrame"..i):SetAlpha(newChatMaxAlpha)
  end
 end
end


function MiniChat:GetScale()
 return self.db.profile.Scale
end
function MiniChat:SetScale(newScale)
 self.db.profile.Scale=newScale
 MiniB:SetWidth(15*newScale)
 MiniB:SetHeight(15*newScale)
end


function MiniChat:GetHandleAll()
 return self.db.profile.HandleAll
end
function MiniChat:SetHandleAll(newHandleAll)
 self.db.profile.HandleAll=newHandleAll
 if(newHandleAll) then
  handleCount=NUM_CHAT_WINDOWS
 else
  handleCount=1
 end
end


function MiniChat:GetClamped()
 return self.db.profile.Clamped
end
function MiniChat:SetClamped(newClamped)
 self.db.profile.Clamped=newClamped
 MiniB:SetClampedToScreen(newClamped)
end


function MiniChat:GetUnlock()
 return self.db.profile.Unlock
end
function MiniChat:SetUnlock(newUnlock)
 self.db.profile.Unlock=newUnlock
end


function MiniChat:GetPosition()
 return self.db.profile.Position
end
function MiniChat:SetPosition(newPosition)
 self:SetUnlock(false)
 MiniB:ClearAllPoints()
 self.db.profile.Position=newPosition
 MiniB:SetPoint("CENTER",DEFAULT_CHAT_FRAME,newPosition,0,0)
end


function MiniChat:GetAnimationSpeed()
 return self.db.profile.AnimationSpeed
end
function MiniChat:SetAnimationSpeed(newAnimationSpeed)
 self.db.profile.AnimationSpeed=newAnimationSpeed
end


function MiniChat:GetDirection()
 return self.db.profile.Direction
end
function MiniChat:SetDirection(newDirection)
 self.db.profile.Direction=newDirection
 for i=1,handleCount do
  getglobal("ChatFrame"..i):ClearAllPoints()
  if(newDirection=="up") then
   getglobal("ChatFrame"..i):SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT",getglobal("ChatFrame"..i):GetLeft(),getglobal("ChatFrame"..i):GetTop())
  else
   getglobal("ChatFrame"..i):SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",getglobal("ChatFrame"..i):GetLeft(),getglobal("ChatFrame"..i):GetBottom())
  end
 end
end


function MiniChat:GetSmartMinimize()
 return self.db.profile.SmartMinimize
end
function MiniChat:SetSmartMinimize(newSmartMinimize)
 self.db.profile.SmartMinimize=newSmartMinimize
end

function MiniChat:GetAutoMinimize()
 return self.db.profile.AutoMinimize
end
function MiniChat:SetAutoMinimize(newAutoMinimize)
 self.db.profile.AutoMinimize=newAutoMinimize
end
function MiniChat:GetAutoMinimizeAfter()
 return self.db.profile.AutoMinimizeAfter
end
function MiniChat:SetAutoMinimizeAfter(newAutoMinimizeAfter)
 self.db.profile.AutoMinimizeAfter=newAutoMinimizeAfter
end

function MiniChat:GetAutoMaximizeEnabled()
 return self.db.profile.AutoMaximizeEnabled
end
function MiniChat:SetAutoMaximizeEnabled(newAutoMaximizeEnabled)
 self.db.profile.AutoMaximizeEnabled=newAutoMaximizeEnabled
end

function MiniChat:GetAutoMaximizeIgnoreIfInCombat()
 return self.db.profile.AutoMaximizeIgnoreIfInCombat
end
function MiniChat:SetAutoMaximizeIgnoreIfInCombat(newAutoMaximizeIgnoreIfInCombat)
 self.db.profile.AutoMaximizeIgnoreIfInCombat=newAutoMaximizeIgnoreIfInCombat
end
function MiniChat:GetAutoMaximizeIgnoreSelf()
 return self.db.profile.AutoMaximizeIgnoreSelf
end
function MiniChat:SetAutoMaximizeIgnoreSelf(newAutoMaximizeIgnoreSelf)
 self.db.profile.AutoMaximizeIgnoreSelf=newAutoMaximizeIgnoreSelf
end
function MiniChat:GetAutoMaximizeOnYell()
 return self.db.profile.AutoMaximizeOnYell
end
function MiniChat:SetAutoMaximizeOnYell(newAutoMaximizeOnYell)
 self.db.profile.AutoMaximizeOnYell=newAutoMaximizeOnYell
end
function MiniChat:GetAutoMaximizeOnSay()
 return self.db.profile.AutoMaximizeOnSay
end
function MiniChat:SetAutoMaximizeOnSay(newAutoMaximizeOnSay)
 self.db.profile.AutoMaximizeOnSay=newAutoMaximizeOnSay
end
function MiniChat:GetAutoMaximizeOnWhisper()
 return self.db.profile.AutoMaximizeOnWhisper
end
function MiniChat:SetAutoMaximizeOnWhisper(newAutoMaximizeOnWhisper)
 self.db.profile.AutoMaximizeOnWhisper=newAutoMaximizeOnWhisper
end
function MiniChat:GetAutoMaximizeOnGuild()
 return self.db.profile.AutoMaximizeOnGuild
end
function MiniChat:SetAutoMaximizeOnGuild(newAutoMaximizeOnGuild)
 self.db.profile.AutoMaximizeOnGuild=newAutoMaximizeOnGuild
end
function MiniChat:GetAutoMaximizeOnParty()
 return self.db.profile.AutoMaximizeOnParty
end
function MiniChat:SetAutoMaximizeOnParty(newAutoMaximizeOnParty)
 self.db.profile.AutoMaximizeOnParty=newAutoMaximizeOnParty
end
function MiniChat:GetAutoMaximizeOnRaid()
 return self.db.profile.AutoMaximizeOnRaid
end
function MiniChat:SetAutoMaximizeOnRaid(newAutoMaximizeOnRaid)
 self.db.profile.AutoMaximizeOnRaid=newAutoMaximizeOnRaid
end
function MiniChat:GetAutoMaximizeOnBattleground()
 return self.db.profile.AutoMaximizeOnBattleground
end
function MiniChat:SetAutoMaximizeOnBattleground(newAutoMaximizeOnBattleground)
 self.db.profile.AutoMaximizeOnBattleground=newAutoMaximizeOnBattleground
end
function MiniChat:GetAutoMaximizeOnOfficer()
 return self.db.profile.AutoMaximizeOnOfficer
end
function MiniChat:SetAutoMaximizeOnOfficer(newAutoMaximizeOnOfficer)
 self.db.profile.AutoMaximizeOnOfficer=newAutoMaximizeOnOfficer
end
function MiniChat:GetAutoMaximizeOnChannel1()
 return self.db.profile.AutoMaximizeOnChannel[1]
end
function MiniChat:SetAutoMaximizeOnChannel1(newAutoMaximizeOnChannel1)
 self.db.profile.AutoMaximizeOnChannel[1]=newAutoMaximizeOnChannel1
end
function MiniChat:GetAutoMaximizeOnChannel2()
 return self.db.profile.AutoMaximizeOnChannel[2]
end
function MiniChat:SetAutoMaximizeOnChannel2(newAutoMaximizeOnChannel2)
 self.db.profile.AutoMaximizeOnChannel[2]=newAutoMaximizeOnChannel2
end
function MiniChat:GetAutoMaximizeOnChannel3()
 return self.db.profile.AutoMaximizeOnChannel[3]
end
function MiniChat:SetAutoMaximizeOnChannel3(newAutoMaximizeOnChannel3)
 self.db.profile.AutoMaximizeOnChannel[3]=newAutoMaximizeOnChannel3
end
function MiniChat:GetAutoMaximizeOnChannel4()
 return self.db.profile.AutoMaximizeOnChannel[4]
end
function MiniChat:SetAutoMaximizeOnChannel4(newAutoMaximizeOnChannel4)
 self.db.profile.AutoMaximizeOnChannel[4]=newAutoMaximizeOnChannel4
end
function MiniChat:GetAutoMaximizeOnChannel5()
 return self.db.profile.AutoMaximizeOnChannel[5]
end
function MiniChat:SetAutoMaximizeOnChannel5(newAutoMaximizeOnChannel5)
 self.db.profile.AutoMaximizeOnChannel[5]=newAutoMaximizeOnChannel5
end
function MiniChat:GetAutoMaximizeOnChannel6()
 return self.db.profile.AutoMaximizeOnChannel[6]
end
function MiniChat:SetAutoMaximizeOnChannel6(newAutoMaximizeOnChannel6)
 self.db.profile.AutoMaximizeOnChannel[6]=newAutoMaximizeOnChannel6
end
function MiniChat:GetAutoMaximizeOnChannel7()
 return self.db.profile.AutoMaximizeOnChannel[7]
end
function MiniChat:SetAutoMaximizeOnChannel7(newAutoMaximizeOnChannel7)
 self.db.profile.AutoMaximizeOnChannel[7]=newAutoMaximizeOnChannel7
end
function MiniChat:GetAutoMaximizeOnChannel8()
 return self.db.profile.AutoMaximizeOnChannel[8]
end
function MiniChat:SetAutoMaximizeOnChannel8(newAutoMaximizeOnChannel8)
 self.db.profile.AutoMaximizeOnChannel[8]=newAutoMaximizeOnChannel8
end
function MiniChat:GetAutoMaximizeOnChannel9()
 return self.db.profile.AutoMaximizeOnChannel[9]
end
function MiniChat:SetAutoMaximizeOnChannel9(newAutoMaximizeOnChannel9)
 self.db.profile.AutoMaximizeOnChannel[9]=newAutoMaximizeOnChannel9
end
function MiniChat:GetAutoMaximizeOnChannel10()
 return self.db.profile.AutoMaximizeOnChannel[10]
end
function MiniChat:SetAutoMaximizeOnChannel10(newAutoMaximizeOnChannel10)
 self.db.profile.AutoMaximizeOnChannel[10]=newAutoMaximizeOnChannel10
end


function MiniChat:MiniMax(i)
 lower[i]=self:GetLastMsgHeight(i)
 self.db.profile.ChatLeft[i]=getglobal("ChatFrame"..i):GetLeft()
 self.db.profile.ChatBottom[i]=getglobal("ChatFrame"..i):GetBottom()
 if(not self.db.profile.Minimized[i]) then -- maximized
  self.db.profile.ChatHeight[i]=getglobal("ChatFrame"..i):GetHeight()
  if(self.db.profile.AnimationSpeed==0) then
   getglobal("ChatFrame"..i):SetHeight(lower[i])
   self:UpdateChatAlpha(i)
  end
  if(self.db.profile.Direction=="down") then
   getglobal("ChatFrame"..i):ClearAllPoints()
   getglobal("ChatFrame"..i):SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft[i],self.db.profile.ChatBottom[i])
  end
  self.db.profile.Minimized[i]=true
  self:CancelScheduledEvent("minichatautominimize")
 else -- minimized
  if(self.db.profile.AnimationSpeed==0) then
   getglobal("ChatFrame"..i):SetHeight(self.db.profile.ChatHeight[i])
   self:UpdateChatAlpha(i)
  end
  if(self.db.profile.Direction=="down") then
   getglobal("ChatFrame"..i):ClearAllPoints()
   getglobal("ChatFrame"..i):SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft[i],self.db.profile.ChatBottom[i])
  end
  self.db.profile.Minimized[i]=false
  if(self.db.profile.AutoMinimize) then
   self:ScheduleEvent("minichatautominimize","MINICHAT_AUTOMINIMIZE",self.db.profile.AutoMinimizeAfter)
  end
 end
 if(self.db.profile.AnimationSpeed>0) then
  MiniB:Disable()
  self:ScheduleEvent("minichatsmoothing"..i,"MINICHAT_SMOOTHING",0.025,i,not self.db.profile.Minimized[i])
 else
  getglobal("ChatFrame"..i):ScrollDown()
 end
 if(i==1) then
  if(self.db.profile.Minimized[1]) then
   MiniB:SetNormalTexture("Interface\\Addons\\MiniChat\\textures\\button-up.tga")
   MiniB:SetPushedTexture("Interface\\Addons\\MiniChat\\textures\\button-up-pushed.tga")
  else
   MiniB:SetNormalTexture("Interface\\Addons\\MiniChat\\textures\\button-down.tga")
   MiniB:SetPushedTexture("Interface\\Addons\\MiniChat\\textures\\button-down-pushed.tga")
  end
 end
end

function MiniChat:CHAT_MSG_CHANNEL_NOTICE()
 if(arg1=="YOU_JOINED") then
  chan[arg8]=arg9
 else -- "YOU_LEFT"
  local _,channelname=GetChannelName(arg8)
  if(channelname==nil) then
   chan[arg8]="-"
  else
   chan[arg8]=arg9
  end
 end
 self:UpdateOptions()
end

function MiniChat:PLAYER_REGEN_ENABLED()
 if(maximizeAfterCombat) then
  maximizeAfterCombat=false
  for i=1,handleCount do
   if(self.db.profile.Minimized[i]) then
    self:MiniMax(i)
   end
  end
 end
end

function MiniChat:CHAT_MSG_CHANNEL(_,author,_,_,_,_,_,nr)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 local _,channelname=GetChannelName(nr)
 for i=1,handleCount do
  if(self:ScanTable(channelname,channelsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnChannel[nr])
  end
 end
end
function MiniChat:CHAT_MSG_YELL(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("YELL",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnYell)
  end
 end
end
function MiniChat:CHAT_MSG_SAY(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("SAY",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnSay)
  end
 end
end
function MiniChat:CHAT_MSG_WHISPER(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("WHISPER",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnWhisper)
  end
 end
end
function MiniChat:CHAT_MSG_WHISPER_INFORM()
 if(self.db.profile.AutoMaximizeIgnoreSelf) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("WHISPER",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnWhisper)
  end
 end
end
function MiniChat:CHAT_MSG_GUILD(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("GUILD",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnGuild)
  end
 end
end
function MiniChat:CHAT_MSG_PARTY(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("PARTY",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnParty)
  end
 end
end
function MiniChat:CHAT_MSG_RAID(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("PARTY",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnRaid)
  end
 end
end
function MiniChat:CHAT_MSG_RAID_LEADER(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("PARTY",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnRaid)
  end
 end
end
function MiniChat:CHAT_MSG_BATTLEGROUND(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("PARTY",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnBattleground)
  end
 end
end
function MiniChat:CHAT_MSG_BATTLEGROUND_LEADER(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("PARTY",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnBattleground)
  end
 end
end
function MiniChat:CHAT_MSG_BG_SYSTEM_ALLIANCE()
 for i=1,handleCount do
  if(self:ScanTable("SYSTEM",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnBattleground)
  end
 end
end
function MiniChat:CHAT_MSG_BG_SYSTEM_HORDE()
 for i=1,handleCount do
  if(self:ScanTable("SYSTEM",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnBattleground)
  end
 end
end
function MiniChat:CHAT_MSG_BG_SYSTEM_NEUTRAL()
 for i=1,handleCount do
  if(self:ScanTable("SYSTEM",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnBattleground)
  end
 end
end
--function MiniChat:UPDATE_WORLD_STATES()
-- for i=1,handleCount do
--  if(self:ScanTable("SYSTEM",msgsRcvdByWindow[i])) then
--   self:CatchMessage(i,self.db.profile.AutoMaximizeOnBattleground)
--  end
-- end
--end
function MiniChat:CHAT_MSG_OFFICER(_,author)
 if(self.db.profile.AutoMaximizeIgnoreSelf and author==UnitName("player")) then
  return
 end
 for i=1,handleCount do
  if(self:ScanTable("GUILD",msgsRcvdByWindow[i])) then
   self:CatchMessage(i,self.db.profile.AutoMaximizeOnOfficer)
  end
 end
end
function MiniChat:CatchMessage(i,msgtypeenabled)
 if(self.db.profile.AutoMaximizeEnabled and msgtypeenabled) then
  if(self.db.profile.AutoMaximizeIgnoreIfInCombat and UnitAffectingCombat("player")) then
   maximizeAfterCombat=true
   return
  end
  if(self.db.profile.AutoMinimize) then
    if(self:IsEventScheduled("minichatautominimize")) then
     self:CancelScheduledEvent("minichatautominimize")
    end
    self:ScheduleEvent("minichatautominimize","MINICHAT_AUTOMINIMIZE",self.db.profile.AutoMinimizeAfter)
  end
  if(self.db.profile.Minimized[i]) then
   self:MiniMax(i)
  end
 end
end

function MiniChat:MINICHAT_AUTOMINIMIZE()
 for i=1,handleCount do
  if(not self.db.profile.Minimized[i]) then
   self:MiniMax(i)
  end
 end
end

function MiniChat:MINICHAT_SMOOTHING(i,expand)
 if(expand) then
  getglobal("ChatFrame"..i):SetHeight(math.floor(getglobal("ChatFrame"..i):GetHeight()+2+self.db.profile.AnimationSpeed*getglobal("ChatFrame"..i):GetHeight()/120))
  if(getglobal("ChatFrame"..i):GetHeight()>self.db.profile.ChatHeight[i]) then
   getglobal("ChatFrame"..i):SetHeight(self.db.profile.ChatHeight[i])
  end
 else
  getglobal("ChatFrame"..i):SetHeight(math.ceil(getglobal("ChatFrame"..i):GetHeight()-2-self.db.profile.AnimationSpeed*getglobal("ChatFrame"..i):GetHeight()/120))
  if(getglobal("ChatFrame"..i):GetHeight()<lower[i]) then
   getglobal("ChatFrame"..i):SetHeight(lower[i])
  end
 end
 if(self.db.profile.Direction=="down") then
  getglobal("ChatFrame"..i):ClearAllPoints()
  getglobal("ChatFrame"..i):SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",self.db.profile.ChatLeft[i],self.db.profile.ChatBottom[i])
 end
 if((getglobal("ChatFrame"..i):GetHeight()>lower[i] and not expand)
    or
    (getglobal("ChatFrame"..i):GetHeight()<self.db.profile.ChatHeight[i] and expand)) then
  self:ScheduleEvent("minichatsmoothing"..i,"MINICHAT_SMOOTHING",0.025,i,expand)
 else
  getglobal("ChatFrame"..i):ScrollDown()
  MiniB:Enable()
 end
 self:UpdateChatAlpha(i)
end